/*                                                               `
 genx realtime terrain visualization
 (c) 2004-2005 Witold Bolt <ja@hope.art.pl>

 file: help.c

 help screen

*/

#include <GL/gl.h>
#include <GL/glext.h>
#include "SDL.h"
#include "SDL_image.h"

#include "genx.h"
#include "help.h"
#include "error.h"
#include "gsys.h"

SDL_bool help_mode=SDL_TRUE;

GLuint helpTexturePrepare()
{
 GLuint temp;
 SDL_Surface *Image;
 GLenum ImageType;

 Image = IMG_Load("textures/help.bmp");

 if (!Image) {
 fprintf(debug,"ERROR: loading help failed with error: %s\n",IMG_GetError());
 return(-1);
 }

#ifdef DEBUG
 else
 fprintf(debug,"debug: help texture file is ok:)\n");
#endif

  if(Image->format->BytesPerPixel == 3) ImageType=GL_RGB;
  else if(Image->format->BytesPerPixel == 4) ImageType=GL_RGBA;
  else { fprintf(debug,"ERROR: help texture file is in unsupported pixel format!\n");
         return(-1);
       }

  glGenTextures(1, &temp);
  glBindTexture(GL_TEXTURE_2D, temp);
  glTexImage2D(GL_TEXTURE_2D,0, Image->format->BytesPerPixel, Image->w, Image->h, 0, ImageType, GL_UNSIGNED_BYTE, Image->pixels);
  

#ifdef DEBUG
  process_errors();
  SDL_FreeSurface(Image);
  fprintf(debug,"debug: done with preparing help texture.\n");
#endif
  return(temp);
}


void helpPrepare()
{
    glNewList(HELP_DISPLAY_LIST,GL_COMPILE);
    glColor4f(1.0f,1.0f,1.0f,1.0f);
    glBindTexture(GL_TEXTURE_2D, helpTexturePrepare());
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    glBegin(GL_QUADS);      
        glTexCoord2f(0.0f,1.0f); glVertex2f(0.1875f * (float)genxScreen->w, 0.0833f * (float)genxScreen->h);
        glTexCoord2f(0.0f,0.0f); glVertex2f(0.1875f * (float)genxScreen->w, 0.916f * (float)genxScreen->h);
        glTexCoord2f(1.0f,0.0f); glVertex2f(0.875f * (float)genxScreen->w, 0.916f * (float)genxScreen->h); 
        glTexCoord2f(1.0f,1.0f); glVertex2f(0.875f * (float)genxScreen->w, 0.0833f * (float)genxScreen->h);
    glEnd();
    glEndList();
}
